(function(window, document, undefined){

var instance = null;
if (typeof define == 'function') {
	define('ac', function () {
		return new Access();
	});
}
else {
	window['access'] = new Access();
}

function Access() { if (instance) return instance;
	var self = this;

	var levels = {
		'admin': ['sys','db','svg','svgwr','files','xmlrd','xmlwr','tu','restart','update','time'],
		'custom': ['sys','db','svg','files','xmlrd','xmlwr','tu','restart'],
		'user': ['sys','db','svg','files','xmlrd','xmlwr','restart'],
		'operator': ['db','svg','xmlrd']
	}
	
	var getRole = function(user) {
	  var level = ['admin', 'custom', 'user', 'operator'].filter(function(level) {
		return levels[level].every(function(a){return a in self})
	  });
	  return level[0] || model.levels['operator'];
	}
	
	self['level'] = function(access_array, callback, error){
		var notAccess = access_array[0] == '!',
			isInArray = !!~access_array.indexOf(self.role),
			allowedAccess = notAccess ? !isInArray : isInArray;
		
		allowedAccess ? callback && callback()
					  : error && error();	
			
		return allowedAccess;
	}
	
	var r = new XMLHttpRequest();
		r.open("GET", '/~access', false);
		if (typeof exports != 'undefined' && exports.requestHeaders){
			Object.keys(exports.requestHeaders).forEach(function(key) {
				r.setRequestHeader(key, exports.requestHeaders[key]);
			});
		}
		r.ontimeout = function(){};
		r.onerror = function(){};
		r.onload = function(){
			if (r.readyState == 4) {
				if(r.status == 200){
					var data = r.responseText;
					data = data.split(';');
					var user = data.length > 1 ? data[0]:'';
					
					data = data[data.length-1];				
					data.split(',').map(function(e){
						self[e] = e;
					});
					self['name'] = user;
					/*self['role'] = self['admin'] 
								|| self['custom'] 
								|| self['user'] 
								|| self['operator']
								|| 'admin';*/
					self['role'] = getRole(user);
				}
				r.onload =
				r.onerror =
				r.ontimeout = null;;
			}	
		};
	r.send(null);
  
	instance = this;
};
})(window, document, undefined) 